<template>
  <q-page padding class="height-0 column">
    <div class="col row gutter-sm">
      <div class="col-xs-12 col-md-5 col-lg-4">
        <div class="column full-height">
          <q-scroll-area class="col" :thumb-style="{right: '0', borderRadius: '4px', background: '#d12', opacity: .6, width: '10px'}">
            <q-collapsible label="Initial Video" :value="true" header-class="q-title">
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.restrict_access" color="negative" label="Don't show in irewind.com" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.demo_show" color="dark" label="Show video" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.demo_autoplay" color="dark" label="Autoplay initial video" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.no_list" color="dark" label="Don't show list and search" />
              </div>
              <div class="relative-position row items-center gutter-xs q-my-md">
                <div class="col-auto">
                  <q-btn no-caps color="primary" @click="filePick('demo_video_url')" :disable="!fileCanAdd('demo_video_url')">
                    Upload Video
                  </q-btn>
                </div>
                <input type="file" ref="file_demo_video_url"
                  class="q-uploader-input absolute-full cursor-pointer"
                  accept="video/mp4"
                  @change="fileAdd($event, 'demo_video_url')"
                />
                <div class="col" v-for="file in files['demo_video_url']" :key="file.__fileId">
                  {{file.name}}
                  <q-icon v-if="file.__doneUploading && !file.__failed" name="check" color="positive" />
                  <div v-if="uploading" class="q-my-sm">
                    <q-progress animate
                      :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                      :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                    ></q-progress>
                  </div>
                </div>
              </div>
              <q-btn color="primary" flat class="full-width" icon-right="open_in_new" label="Current Video" v-if="config.demo_video_url" @click="openURL(config.demo_video_url)" />
              <div class="relative-position row items-center gutter-xs q-my-md">
                <div class="col-auto">
                  <q-btn no-caps color="primary" @click="filePick('demo_thumbnail_url')" :disable="!fileCanAdd('demo_thumbnail_url')">
                    Upload Video Cover
                  </q-btn>
                </div>
                <input type="file" ref="file_demo_thumbnail_url"
                  class="q-uploader-input absolute-full cursor-pointer"
                  accept="image/*"
                  @change="fileAdd($event, 'demo_thumbnail_url')"
                />
                <div class="col" v-for="file in files['demo_thumbnail_url']" :key="file.__fileId">
                  {{file.name}}
                  <q-icon v-if="file.__doneUploading && !file.__failed" name="check" color="positive" />
                  <div v-if="uploading" class="q-my-sm">
                    <q-progress animate
                      :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                      :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                    ></q-progress>
                  </div>
                </div>
              </div>
              <q-btn color="primary" flat class="full-width" icon-right="open_in_new" label="Current Video Cover" v-if="config.demo_thumbnail_url" @click="openURL(config.demo_thumbnail_url)" />

              <div class="relative-position row items-center gutter-xs q-my-md">
                <div class="col-auto">
                  <q-btn no-caps color="primary" @click="filePick('logo_img')" :disable="!fileCanAdd('logo_img')">
                    Logo Image (Top Left)
                  </q-btn>
                </div>
                <input type="file" ref="file_logo_img"
                  class="q-uploader-input absolute-full cursor-pointer"
                  accept="image/*"
                  @change="fileAdd($event, 'logo_img')"
                />
                <div class="col" v-for="file in files['logo_img']" :key="file.__fileId">
                  {{file.name}}
                  <q-icon v-if="file.__doneUploading && !file.__failed" name="check" color="positive" />
                  <div v-if="uploading" class="q-my-sm">
                    <q-progress animate
                      :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                      :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                    ></q-progress>
                  </div>
                </div>
              </div>
              <div class="relative-position row items-center justify-between q-my-md" v-if="config.logo_img">
                <q-btn color="primary" flat icon-right="open_in_new" label="Logo Image" @click="openURL(config.logo_img)" />
                <q-btn color="negative" flat icon="cancel" @click="config.logo_img = ''" />
              </div>
            </q-collapsible>
            <q-collapsible label="Components" :value="true" header-class="q-title">
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.autoplay" color="dark" label="Autoplay user video" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.unstructured_show" color="dark" label="Show unstructured images link" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.gallery_show" color="dark" label="Show gallery" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.gallery_time_filter_show" color="dark" label="Show gallery filtered by time" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.ranking_show" color="dark" @input="onChangeRankingShow" label="Show ranking" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.ranking_start" color="dark" @input="onChangeRankingStart" label="Start with ranking" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.gif_show" color="dark" label="Show GIF with video" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.no_back_link" color="dark" label="Don't show back link on player" />
              </div>
            </q-collapsible>
            <q-collapsible label="Color" :value="true" header-class="q-title">
              <q-color float-label="Primary color" class="q-mt-none" color="none" inverted :style="{backgroundColor: config.cssReplace.red}"
                :value="config.cssReplace.red"
                @change="(value) => config.cssReplace.red = value"
              />
            </q-collapsible>
            <q-collapsible label="Call to Actions" :value="true" header-class="q-title">
              <div class="shadow-2 bg-grey-1 q-pa-sm q-my-sm" v-for="(cta, index) in config.callToAction" :key="index">
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  hide-underline
                  color="dark"
                  float-label="Label (used for GA)"
                  :value="cta.label"
                  @change="(val) => setCallToAction(index, { label: val })"
                />
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  hide-underline
                  color="dark"
                  float-label="Url to open (or share action)"
                  :value="cta.url"
                  @change="(val) => setCallToAction(index, { url: val })"
                >
                  <q-popover no-focus no-refocus fit :offset="[0, 5]">
                    <q-list link>
                      <q-item v-for="action in ctaActions" :key="action.sublabel" @click.native="setCallToAction(index, { url: action.sublabel })">
                        <q-item-main :label="action.label" :sublabel="action.sublabel" />
                      </q-item>
                    </q-list>
                  </q-popover>
                </q-input>
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  hide-underline
                  color="dark"
                  float-label="Show at time (ms, negative is from end)"
                  :value="cta.timeStart"
                  @change="(val) => setCallToAction(index, { timeStart: val })"
                />
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  hide-underline
                  color="dark"
                  float-label="Hide at time (ms, negative is from end)"
                  :value="cta.timeEnd"
                  @change="(val) => setCallToAction(index, { timeEnd: val })"
                />
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  type="textarea"
                  hide-underline
                  color="dark"
                  float-label="CSS Style (JSON)"
                  :value="cta.style"
                  @change="(val) => setCallToAction(index, { style: val })"
                />
                <div class="q-mb-md">
                  <q-btn color="faded" class="full-width" label="Position overlay" @click="onCtaOverlayOpen(index)" />
                </div>
                <q-input
                  class="shadow-2 q-pa-sm q-mb-xs bg-white"
                  hide-underline
                  color="dark"
                  float-label="Overlay image URL"
                  :value="cta.img"
                  @change="(val) => setCallToAction(index, { img: val })"
                />
                <div class="relative-position q-mb-md">
                  <q-btn no-caps color="primary" class="full-width" @click="filePick('overlay_img_url')">
                    Upload Overlay image
                  </q-btn>
                  <input type="file" ref="file_overlay_img_url"
                    class="q-uploader-input absolute-full cursor-pointer"
                    accept="image/*"
                    @change="fileAdd($event, 'overlay_img_url', index)"
                  />
                  <div v-for="file in files['overlay_img_url']" :key="file.__fileId">
                    {{file.name}}
                    <q-icon v-if="file.__doneUploading && !file.__failed" name="check" color="positive" />
                    <div v-if="uploading" class="q-my-sm">
                      <q-progress animate
                        :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                        :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                      ></q-progress>
                    </div>
                  </div>
                </div>
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  type="textarea"
                  hide-underline
                  color="dark"
                  float-label="CSS Style for Overlay image (JSON)"
                  :value="cta.style_img"
                  @change="(val) => setCallToAction(index, { style_img: val })"
                />
                <q-input
                  class="shadow-2 q-pa-sm q-mb-md bg-white"
                  type="number"
                  hide-underline
                  color="dark"
                  float-label="Pause duration (sec)"
                  :value="cta.pause"
                  @change="(val) => setCallToAction(index, { pause: val })"
                  :disable="cta.pause === true"
                />
                <div class="q-mb-md">
                  <q-checkbox :value="cta.pause === true" color="dark" label="Pause until resume" @change="(val) => { cta.pause = val || 0; }" />
                </div>
                <div class="q-mb-md">
                  <q-checkbox v-model="cta.debug" color="dark" label="Debug mode (show overlay)" />
                </div>
                <div>
                  <q-btn color="negative" class="full-width" label="Remove Call to Action" @click="removeCallToAction(index)" />
                </div>
              </div>
              <q-btn color="positive" class="full-width" label="Add Call to Action" @click="addCallToAction()" />
            </q-collapsible>
            <q-collapsible :label="`Languages: ${ config.lang || 'NONE' }`" :value="false" header-class="q-title">
              <div class="row q-mb-sm">
                <div class="col">Show</div>
                <div class="col-auto text-faded"><small>Default</small></div>
              </div>
              <div class="row q-mb-md" v-for="lang in langs" :key="lang.id">
                <div class="col">
                  <q-checkbox v-model="lang.selected" color="dark" @input="onChangeLang()" :label="lang.name" />
                </div>
                <q-radio v-model="lang_default" :val="lang.id" color="dark" @input="onChangeLang()" :disable="!lang.selected" />
              </div>
            </q-collapsible>
            <q-collapsible label="Titles" :value="false" header-class="q-title">
              <q-input v-for="lang in langs" :key="lang.id"
                class="shadow-2 q-pa-sm q-mb-md bg-white"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                :float-label="lang.name"
                :value="config.title[lang.id]"
                @change="(val) => setTitle(lang.id, val)"
              />
            </q-collapsible>
            <q-collapsible label="Sharing - General" :value="false" header-class="q-title">
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.facebook" color="dark" label="Show 'Share with Facebook' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.facebookWithIrw" color="negative" keep-color label="Show 'Share with Facebook' button using iRewind helper" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.twitter" color="dark" label="Show 'Share with Twitter' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.whatsapp" color="dark" label="Show 'Share with Whatsapp' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.link" color="dark" label="Show 'Share with Link' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.email" color="dark" label="Show 'Share with eMail' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.download" color="dark" label="Show 'Download' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.ss_jpg" color="dark" label="Show 'Take Screenshot' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.ss_gif" color="dark" label="Show 'Create GIF' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.pr_jpg" color="dark" label="Show 'Print Screenshot' button" />
              </div>
              <div class="relative-position row items-center gutter-xs q-my-md">
                <div class="col-auto">
                  <q-btn no-caps color="primary" @click="filePick('facebook_img')" :disable="!fileCanAdd('facebook_img')">
                    Facebook Image
                  </q-btn>
                </div>
                <input type="file" ref="file_facebook_img"
                  class="q-uploader-input absolute-full cursor-pointer"
                  accept="image/*"
                  @change="fileAdd($event, 'facebook_img')"
                />
                <div class="col" v-for="file in files['facebook_img']" :key="file.__fileId">
                  {{file.name}}
                  <q-icon v-if="file.__doneUploading && !file.__failed" name="check" color="positive" />
                  <div v-if="uploading" class="q-my-sm">
                    <q-progress animate
                      :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                      :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                    ></q-progress>
                  </div>
                </div>
              </div>
              <div class="relative-position row items-center justify-between q-my-md" v-if="config.share.facebook_img">
                <q-btn color="primary" flat icon-right="open_in_new" label="Facebook Share Image" @click="openURL(config.share.facebook_img)" />
                <q-btn color="negative" flat icon="cancel" @click="config.share.facebook_img = config.share.player.facebook_img = ''" />
              </div>
            </q-collapsible>
            <q-collapsible label="Facebook Sharing Texts" :value="false" header-class="q-title">
              <q-input
                class="shadow-2 q-pa-sm q-mb-md bg-grey-2"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                float-label="Default Text"
                :value="config.facebookText['*']"
                @change="(val) => setFacebookText('*', val)"
              />
              <q-input v-for="lang in langs" :key="lang.id"
                class="shadow-2 q-pa-sm q-mb-md bg-white"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                :float-label="lang.name"
                :value="config.facebookText[lang.id]"
                @change="(val) => setFacebookText(lang.id, val)"
              />
            </q-collapsible>
            <q-collapsible label="Twitter Sharing Texts" :value="false" header-class="q-title">
              <q-input
                class="shadow-2 q-pa-sm q-mb-md bg-grey-2"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                float-label="Default Text"
                :value="config.twitterText['*']"
                @change="(val) => setTwitterText('*', val)"
              />
              <q-input v-for="lang in langs" :key="lang.id"
                class="shadow-2 q-pa-sm q-mb-md bg-white"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                :float-label="lang.name"
                :value="config.twitterText[lang.id]"
                @change="(val) => setTwitterText(lang.id, val)"
              />
            </q-collapsible>
            <q-collapsible label="Whatsapp Sharing Texts" :value="false" header-class="q-title">
              <q-input
                class="shadow-2 q-pa-sm q-mb-md bg-grey-2"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                float-label="Default Text"
                :value="config.whatsappText['*']"
                @change="(val) => setWhatsappText('*', val)"
              />
              <q-input v-for="lang in langs" :key="lang.id"
                class="shadow-2 q-pa-sm q-mb-md bg-white"
                type="textarea"
                :rows="1"
                hide-underline
                color="dark"
                :float-label="lang.name"
                :value="config.whatsappText[lang.id]"
                @change="(val) => setWhatsappText(lang.id, val)"
              />
            </q-collapsible>
            <q-collapsible label="Sharing - Player" :value="false" header-class="q-title">
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.facebook" color="dark" label="Show 'Share with Facebook' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.facebookWithIrw" color="negative" keep-color label="Show 'Share with Facebook' button using iRewind helper" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.twitter" color="dark" label="Show 'Share with Twitter' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.whatsapp" color="dark" label="Show 'Share with Whatsapp' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.link" color="dark" label="Show 'Share with Link' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.email" color="dark" label="Show 'Share with eMail' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.download" color="dark" label="Show 'Download' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.ss_jpg" color="dark" label="Show 'Take Screenshot' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.ss_gif" color="dark" label="Show 'Create GIF' button" />
              </div>
              <div class="q-mb-md">
                <q-checkbox toggle-indeterminate v-model="config.share.player.pr_jpg" color="dark" label="Show 'Print Screenshot' button" />
              </div>
            </q-collapsible>
          </q-scroll-area>
          <q-btn no-caps color="primary" label="Save configuration to channel" @click="saveConfig" :loading="uploading" class="full-width q-mt-md" />
        </div>
      </div>
      <div class="col-xs-12 col-md-7 col-lg-8" v-if="channelId && !$q.platform.is.mobile">
        <div class="column full-height">
          <div class="col">
            <q-card class="q-ma-none fit bg-white">
              <q-card-main class="fit">
                <iframe class="fit no-border"
                  :src="previewUrlIframe"
                  scrolling="no"
                  allow="autoplay; fullscreen"
                  referrerpolicy="unsafe-url"
                ></iframe>
              </q-card-main>
            </q-card>
          </div>
          <div class="col-auto q-mt-sm column">
            <div class="q-py-sm">
              <q-checkbox v-model="iframeCodeConfig.vue" label="Use VUE component" />
              <q-checkbox v-model="iframeCodeConfig.script" label="Use scripts for referrer" />
            </div>
            <q-input type="textarea" color="dark" inverted v-model="iframeCode" class="q-mb-none" />
          </div>
        </div>
      </div>
    </div>
    <q-modal v-model="ctaOverlay.open" content-classes="column no-wrap full-height">
      <div class="col column no-wrap q-ma-lg full-height">
        <q-input v-model="ctaOverlay.video" prefix="Video URL" align="right" outline class="q-py-xs q-mb-sm" />
        <div class="col row items-center">
          <div ref="ctaOverlayHolder" style="position: relative; display: block; height: 0; padding: 0; overflow: hidden; padding-bottom: 56.25%; min-width: 100%;">
            <video :src="ctaOverlay.video" controls class="col" style="position: absolute; top: 0; bottom: 0; left: 0; width: 100%; height: 100%;" />
            <div style="position: absolute; z-index: 10; background: rgba(255, 0, 0, .5);"
              ref="ctaOverlayItem"
              :style="ctaOverlay.style"
            >
              <div style="position: absolute; cursor: ns-resize; top: 0; left: 0; right: 0; height: 3px; background: rgba(255, 0, 0, .7);"
                v-touch-pan.vertical.stop.prevent="(e) => onCtaOverlayPan('top', e)"
              />
              <div style="position: absolute; cursor: ns-resize; bottom: 0; left: 0; right: 0; height: 3px; background: rgba(255, 0, 0, .7);"
                v-touch-pan.vertical.stop.prevent="(e) => onCtaOverlayPan('bottom', e)"
              />
              <div style="position: absolute; cursor: ew-resize; left: 0; top: 0; bottom: 0; width: 3px; background: rgba(255, 0, 0, .7);"
                v-touch-pan.horizontal.stop.prevent="(e) => onCtaOverlayPan('left', e)"
              />
              <div style="position: absolute; cursor: ew-resize; right: 0; top: 0; bottom: 0; width: 3px; background: rgba(255, 0, 0, .7);"
                v-touch-pan.horizontal.stop.prevent="(e) => onCtaOverlayPan('right', e)"
              />
              <div style="position: absolute; cursor: move; left: 15px; right: 15px; top: 15px; bottom: 15px;"
                v-touch-pan.stop.prevent="(e) => onCtaOverlayPan('all', e)"
              />
            </div>
          </div>
        </div>
        <div class="q-mt-sm row gutter-sm items-center">
          <div v-for="(v, k) in ctaOverlay.style" :key="k" class="col">
            <q-input v-model="ctaOverlay.style[k]" :prefix="k" align="right" @keyup="(ev) => onCtaOverlayKey(ev, k)" outline class="q-py-xs" />
          </div>
        </div>
        <q-btn color="primary" class="q-mt-lg" @click="onCtaOverlayClose()" label="Save" />
      </div>
    </q-modal>
  </q-page>
</template>

<script>
  import {
    format,
    clone,
    extend,
    openURL,
    uid,
  } from 'quasar';
  import asmCrypto from 'asmcrypto.js';
  import { CancelToken, isCancel } from 'axios';
  import { mapState } from 'vuex';
  import { stringify } from 'qs';
  import { getRejectionMessage, showRejectionMessage } from '../../utils';

  const { humanStorageSize } = format;
  const chunkSize = 5 * 1024 * 1024;
  const chunkMaxCount = 2;
  const reRange = /(?:bytes=)?\d+-(\d+)$/;
  let fileIdef = 0;

  function parseEndpoint(endpoint) {
    if (/^(https?:)?\/\//.test(endpoint)) return endpoint;
    return endpoint.replace('/video-processor-secured/', '');
  }

  function parseRange(range) {
    const r = reRange.exec(range);
    return r ? parseInt(r[1], 10) + 1 : 0;
  }

  const l = window.location;
  const previewUrl = `${ l.protocol }//${ l.hostname === 'localhost' ? 'irewind.com' : l.hostname }`;

  const defaultCta = {
    url: '',
    timeStart: 0,
    timeEnd: 0,
    style: '',
    debug: false,
    pause: 0,
    img: '',
    style_img: '',
    label: '',
  };

  const defaultConfig = {
    demo_show: true,
    demo_autoplay: true,
    autoplay: false,
    restrict_access: false,
    no_list: false,
    ranking_show: false,
    ranking_start: false,
    unstructured_show: false,
    gallery_show: false,
    gallery_time_filter_show: true,
    gif_show: false,
    no_back_link: false,
    share: {
      facebook: true,
      facebookWithIrw: true,
      facebook_img: '',
      twitter: true,
      whatsapp: true,
      link: true,
      email: true,
      download: true,
      ss_jpg: false,
      ss_gif: false,
      pr_jpg: false,
      player: {
        facebook: true,
        facebookWithIrw: true,
        facebook_img: '',
        twitter: true,
        whatsapp: true,
        link: true,
        email: true,
        download: true,
        ss_jpg: false,
        ss_gif: false,
        pr_jpg: false,
      },
    },
    cssReplace: {
      red: '#d12',
    },
    logo_img: '',
    lang: '',
    title: {},
    facebookText: {},
    twitterText: {},
    whatsappText: {},
    callToAction: [],
    demo_thumbnail_url: '',
    demo_video_url: '',
  };

  const metas = [
    {
      id: 'demo_video_url',
      name: 'Initial video',
      type: 'VIDEO_PROMO',
      demo: true,
    },
    {
      id: 'demo_thumbnail_url',
      name: 'Initial Video Thumbnail',
      type: 'IMAGE',
    },
    {
      id: 'facebook_img',
      name: 'Facebook Sharing Image',
      type: 'IMAGE',
    },
    {
      id: 'logo_img',
      name: 'Logo Image',
      type: 'IMAGE',
    },
    {
      id: 'overlay_img_url',
      name: 'Overlay Image',
      type: 'IMAGE',
    },
  ];

  export default {
    name: 'irwPublish',
    data() {
      return {
        metas,
        files: metas.reduce((acc, meta) => {
          acc[meta.id] = [];
          return acc;
        }, {}),
        uploading: false,
        multiple: false,
        config: clone(defaultConfig),
        langs: [
          { id: 'en', name: 'English', selected: true },
          { id: 'de', name: 'Deutsch', selected: true },
          { id: 'fr', name: 'Francais', selected: true },
          { id: 'it', name: 'Italiano', selected: true },
          { id: 'es', name: 'Español', selected: true },
          { id: 'pl', name: 'Polish', selected: true },
          { id: 'tr', name: 'Turkish', selected: true },
          { id: 'br', name: 'Português', selected: true },
        ],
        lang_default: null,
        configVersion: 1,
        ctaActions: [
          { label: 'Share Facebook', sublabel: 'facebook' },
          { label: 'Share Facebook IRW', sublabel: 'facebook_irw' },
          { label: 'Share Twitter', sublabel: 'twitter' },
          { label: 'Share Whatsapp', sublabel: 'whatsapp' },
        ],
        ctaOverlay: {
          open: false,
          index: 0,
          video: null,
          style: {},
        },
        iframeCodeConfig: {
          vue: true,
          script: true,
        },
      };
    },
    computed: {
      ...mapState('location', [
        'location',
      ]),
      locationId() {
        return this.location ? this.location.id : null;
      },
      channelId() {
        return this.location ? String(this.location.portal_channel_id) : '';
      },
      previewUrl() {
        return this.getPreviewUrl();
      },
      previewUrlIframe() {
        return this.getPreviewUrl(true);
      },
      iframeCode() {
        if (!this.iframeCodeConfig.script) {
          return [
            '<iframe',
            `  src="${ this.previewUrl }"`,
            '  scrolling="no"',
            '  style="width: 100%; min-height: 100vh; border: none;"',
            '  allow="autoplay; fullscreen"',
            '  referrerpolicy="unsafe-url"',
            '></iframe>',
          ].join('\n');
        }
        if (this.iframeCodeConfig.vue) {
          return [
            '<iframe',
            '  scrolling="no"',
            '  style="width: 100%; min-height: 100vh; border: none;"',
            '  allow="autoplay; fullscreen"',
            '  id="irw-iframe"',
            '></iframe>',
            '<script>',
            '  var ifr = document.getElementById(\'irw-iframe\');',
            `  ifr.src = '${ this.previewUrl }' + '?refUrl=' + encodeURIComponent(window.location.href);`,
            ['</', 'script>'].join(''),
          ].join('\n');
        }
        const url = this.previewUrl.split('#');
        return [
          '<iframe',
          '  scrolling="no"',
          '  style="width: 100%; min-height: 100vh; border: none;"',
          '  allow="autoplay; fullscreen"',
          '  id="irw-iframe"',
          '></iframe>',
          '<script>',
          '  var ifr = document.getElementById(\'irw-iframe\');',
          `  ifr.src = '${ url[0] }' + '&refUrl=' + encodeURIComponent(window.location.href) + '#${ url[1] }';`,
          ['</', 'script>'].join(''),
        ].join('\n');
      },
      ctaOverlayStyle() {
        return JSON.stringify(this.ctaOverlay.style);
      },
    },
    methods: {
      humanStorageSize,
      openURL,
      getPreviewUrl(iframe) {
        const options = {};
        if (iframe) {
          options._ = this.configVersion;
          options.irwifrcf = JSON.stringify(this.config);
        }
        if (this.config.cssReplace && typeof this.config.cssReplace.red === 'string') {
          options.red = this.config.cssReplace.red.replace('#', '');
        }
        if (this.config.lang.length) {
          options.lang = this.config.lang;
        }
        options.no_list = this.config.no_list ? 1 : 0;
        options.unstructured_show = this.config.unstructured_show ? 1 : 0;
        options.gallery_show = this.config.gallery_show ? 1 : 0;
        options.gallery_time_filter_show = this.config.gallery_time_filter_show ? 1 : 0;
        options.ranking_show = this.config.ranking_show ? 1 : 0;
        options.ranking_start = this.config.ranking_start ? 1 : 0;
        options.gif_show = this.config.gif_show ? 1 : 0;
        options.no_back_link = this.config.no_back_link ? 1 : 0;
        if (this.iframeCodeConfig.vue) {
          if (iframe) {
            return `${ previewUrl }/vue/general/${ this.channelId }?${ Object.keys(options).map((k) => `${ encodeURIComponent(k) }=${ encodeURIComponent(options[k]) }`).join('&') }`;
          }
          const ranking = options.ranking_start ? '/ranking' : '';
          return `${ previewUrl }/vue/general/${ this.channelId }${ ranking }`;
        }
        return `${ previewUrl }/embed/general/?${ Object.keys(options).map((k) => `${ encodeURIComponent(k) }=${ encodeURIComponent(options[k]) }`).join('&') }#/${ this.channelId }`;
      },
      initFiles() {
        this.files = this.metas.reduce((acc, meta) => {
          acc[meta.id] = [];
          return acc;
        }, {});
      },
      fileCanAdd(metaId) {
        return !this.uploading && this.files[metaId] && (this.multiple || this.files[metaId].length === 0);
      },
      filePick(metaId) {
        if (this.fileCanAdd(metaId) && (this.$q.platform.is.mozilla || this.$q.platform.is.ie)) {
          this.$refs[`file_${ metaId }`].click();
        }
      },
      fileAdd(e, metaId, index) {
        if (!this.fileCanAdd(metaId)) {
          return;
        }

        let files = Array.prototype.slice.call(e.target.files);
        this.$refs[`file_${ metaId }`].value = '';

        files = files
          .filter((file) => !this.files[metaId].some((f) => file.name === f.name && file.size === f.size))
          .map((file) => this.fileInit(file, metaId));
        this.$set(this.files, metaId, this.files[metaId].concat(files));
        if (metaId === 'overlay_img_url') {
          files[0].__promise_checksum.then(() => this
            .startUpload(metaId)
            .then(() => {
              if (this.files[metaId] && this.files[metaId].length && this.files[metaId][0].__resourceUrl) {
                this.setCallToAction(index, { img: this.files[metaId][0].__resourceUrl });
              }
            })
            .catch((err) => {
              console.error(err);
              return true;
            })
            .then(() => {
              this.$set(this.files, metaId, []);
            }));
        }
      },
      fileInit(file, metaId) {
        fileIdef += 1;
        file.__id = fileIdef;
        file.__checksum = null;
        file.__size = humanStorageSize(file.size);
        file.__doneUploading = false;
        file.__failed = false;
        file.__failedStatus = null;
        file.__uploaded = 0;
        file.__progress = 0;
        file.__progress_checksum = 0;
        file.__promise_checksum = this
          .fileChecksum(file, metaId)
          .then((checksum) => {
            file.__checksum = checksum;
            this.$set(this.files, metaId, [...this.files[metaId]]);
            return checksum;
          })
          .catch(() => {
            file.__progress_checksum = 0;
          });
        return file;
      },
      fileChecksum(file, metaId) {
        return new Promise((resolve, reject) => {
          const blobSlice = File.prototype.slice || File.prototype.mozSlice || File.prototype.webkitSlice;
          const chunks = Math.ceil(file.size / chunkSize);
          const fileReader = new FileReader();
          const crypto = new asmCrypto.SHA256();
          let currentChunk = 0;

          function loadNext() {
            const start = currentChunk * chunkSize;
            const end = ((start + chunkSize) >= file.size) ? file.size : start + chunkSize;
            fileReader.readAsArrayBuffer(blobSlice.call(file, start, end));
          }

          crypto.process([file.name, file.size, uid()].join('#'));

          fileReader.onload = (e) => {
            if (file.__removed) {
              reject();
            } else {
              try {
                crypto.process(e.target.result);
                if (currentChunk < chunkMaxCount || currentChunk > chunks - chunkMaxCount - 1) {
                  currentChunk += 1;
                } else {
                  currentChunk = chunks - chunkMaxCount;
                }
                file.__progress_checksum = (currentChunk * 100) / chunks;
                this.$set(this.files, metaId, [...this.files[metaId]]);
                if (currentChunk < chunks) {
                  loadNext();
                } else {
                  resolve(asmCrypto.bytes_to_hex(crypto.finish().result));
                }
              } catch (err) {
                reject(err);
              }
            }
          };

          fileReader.onerror = (err) => {
            reject(err);
          };

          loadNext();
        });
      },
      startUpload(metaIdKey) {
        this.uploading = true;
        let q = Promise.resolve();
        (metaIdKey ? [metaIdKey] : Object.keys(this.files)).forEach((metaId) => {
          const meta = this.metas.find((s) => String(s.id) === String(metaId));
          this.files[metaId].forEach((file) => {
            file.__failed = false;
            file.__failedStatus = null;
          });
          q = q.then(() => this.processUpload(meta)).catch(() => true);
        });
        return q.then(() => {
          this.uploading = false;
          return this.files;
        });
      },
      processUpload(meta) {
        const metaId = String(meta.id);
        const files = this.files[metaId]
          .filter((file) => !file.__failed && !file.__removed && !file.__doneUploading && file.__progress_checksum > 0)
          .sort((a, b) => (a.size * (2 - (a.__progress_checksum / 100))) - (b.size * (2 - (b.__progress_checksum / 100))));
        if (!files.length || !this.uploading) {
          return Promise.resolve();
        }
        const file = files[0];
        file.__cancelToken = CancelToken.source();
        const uploadPromise = () => new Promise((resolve, reject) => {
          if (!this.uploading || file.__removed || !file.__checksum) {
            return reject(new Error());
          }
          const uploadLength = file.size;
          let uploadOffset = 0;
          let endpoint = '/upload';
          const upload = (fileId) => {
            if (uploadOffset >= uploadLength) {
              return resolve({ fileId });
            }
            const blob = file.slice(uploadOffset, uploadOffset + chunkSize);
            return this.$http
              .put(endpoint, blob, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Type': file.type || 'application/octet-stream',
                  'Content-Range': `bytes ${ uploadOffset }-${ (uploadOffset + blob.size) - 1 }/${ uploadLength }`,
                },
                noRetry: true,
                onUploadProgress: (progressEvent) => {
                  file.__uploaded = Math.min(uploadLength, uploadOffset + progressEvent.loaded);
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, metaId, [...this.files[metaId]]);
                  return progressEvent;
                },
              })
              .then((response) => {
                if (response.status === 201) {
                  return resolve({ fileId });
                }
                uploadOffset = parseRange(response.headers.range);
                return upload(response.data ? response.data.fileId : null);
              })
              .catch((rejection) => {
                if (!isCancel(rejection)) {
                  reject(new Error('Invalid Upload-Offset'));
                }
                return reject(rejection);
              });
          };
          const payload = JSON.stringify({
            id: file.__checksum,
            name: file.name,
            meta: {
              location_id: this.locationId,
              meta_type: meta.name,
            },
          });
          return this.$http
            .post(endpoint, payload, {
              cancelToken: file.__cancelToken.token,
              params: {
                uploadType: 'resumable',
              },
              headers: {
                'X-Upload-Content-Type': file.type || 'application/octet-stream',
                'X-Upload-Content-Length': file.size,
                'Content-Type': 'application/json; charset=UTF-8',
              },
              noRetry: true,
            })
            .then((response) => {
              endpoint = parseEndpoint(response.headers.location);
              return endpoint;
            })
            .catch((rejection) => {
              if (rejection.response && rejection.response.status === 409) {
                endpoint = parseEndpoint(rejection.response.headers.location);
                return endpoint;
              }
              return Promise.reject(rejection);
            })
            .then(() => this.$http
              .put(endpoint, null, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Range': `*/${ file.size }`,
                  'Content-Type': file.type || 'application/octet-stream',
                },
                noRetry: true,
              })
              .then((response) => {
                if (response.status === 206) {
                  uploadOffset = parseRange(response.headers.range);
                  file.__uploaded = uploadOffset;
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, metaId, [...this.files[metaId]]);
                  return upload();
                }
                file.__progress = 100;
                this.$set(this.files, metaId, [...this.files[metaId]]);
                return resolve(response);
              }))
            .catch(reject);
        });
        return file.__promise_checksum
          .then(uploadPromise)
          .then(() => {
            file.__doneUploading = true;
            return this.$http
              .post('/resource/create', stringify({
                file: [file.__checksum],
                file_name: [`${ file.__checksum }.${ file.name.split('.').slice(-1).join('').toLowerCase() }`],
                overwrite: false,
                use_id_as_name: true,
                use_name_as_id: false,
                mime_type: file.type,
                type: meta.type,
                storage_server_id: 14, // public resource
                stop_on_error: true,
                metadata: JSON.stringify({
                  location_id: this.locationId,
                  meta_type: meta.name,
                  meta_id: meta.id,
                  file_name: file.name,
                  file_size: file.size,
                  file_type: file.type,
                  uploaded_timestamp: (new Date()).valueOf(),
                  demo: !!meta.demo,
                  channel_id: this.channelId,
                }),
                demo: !!meta.demo,
                channel_id: this.channelId,
              }, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              })
              .then((response) => {
                file.__resourceId = response.data.resources[0].resource.id;
                return this.$http
                  .get('/resource/getDetails', { params: { id: file.__resourceId } })
                  .then((response2) => {
                    const __resourceUrl = response2.data.results[0].PUBLIC_LINK || response2.data.results[0].url;
                    file.__resourceUrl = __resourceUrl.replace(/^http:/, 'https:');
                  });
              })
              .catch((rejection) => {
                const msg = getRejectionMessage(rejection, 'There was an error creating resource.');
                if (!isCancel(rejection) && msg.indexOf('Resource already exists') === -1) {
                  showRejectionMessage(rejection, 'There was an error creating resource.');
                }
                return rejection;
              });
          })
          .catch((error) => {
            if (error !== true) {
              file.__failed = true;
              if (typeof error === 'string') {
                file.__failedStatus = error;
              } else if (isCancel(error)) {
                file.__failedStatus = 'Upload cancelled';
              } else {
                file.__failedStatus = getRejectionMessage(error, 'Error uploading - try again');
              }
            }
            return error;
          })
          .then(() => {
            this.$set(this.files, metaId, [...this.files[metaId]]);
            return this.processUpload(meta);
          });
      },
      currentUploadStats(meta) {
        if (meta) {
          return meta.reduce((acc2, file) => {
            acc2.files += 1;
            acc2.total += file.size;
            acc2.uploaded += file.__uploaded;
            acc2.progress = (acc2.uploaded * 100) / acc2.total;
            return acc2;
          }, {
            files: 0,
            total: 0,
            uploaded: 0,
            progress: 0,
          });
        }
        return Object.values(this.files).reduce((acc1, m) => m.reduce((acc2, file) => {
          acc2.files += 1;
          acc2.total += file.size;
          acc2.uploaded += file.__uploaded;
          acc2.progress = (acc2.uploaded * 100) / acc2.total;
          return acc2;
        }, acc1), {
          files: 0,
          total: 0,
          uploaded: 0,
          progress: 0,
        });
      },
      getConfig() {
        if (!this.location) {
          this.setConfigDefault();
          return;
        }
        this.$http
          .get('/channels/list', {
            params: {
              channel_id: this.channelId,
            },
          })
          .then((response) => {
            const channel = response.data.results.length ? response.data.results[0] : {};
            let config = {};
            try {
              extend(config, defaultConfig, JSON.parse(channel.iframe_config), {
                demo_thumbnail_url: channel.demo_thumbnail_url,
                demo_video_url: channel.demo_video_url,
                banner_url: channel.BANNER_URL,
                picture_url: channel.PICTURE_URL,
              });
            } catch (e) {
              config = clone(defaultConfig);
            }
            config.description = channel.DESCRIPTION || '';
            if (!config.cssReplace) {
              config.cssReplace = clone(defaultConfig.cssReplace);
            }
            if (!config.share) {
              config.share = clone(defaultConfig.share);
            } else if (!config.share.player) {
              config.share.player = clone(defaultConfig.share.player);
            }
            if (typeof config.lang === 'string' && config.lang.length) {
              const langs = (config.lang || '').split(',');
              this.lang_default = langs[0] || '';
              this.langs.forEach((lang) => {
                lang.selected = langs.indexOf(lang.id) !== -1;
              });
            } else {
              this.lang_default = this.langs[0].id;
              this.langs.forEach((lang) => {
                lang.selected = true;
              });
            }
            this.onChangeLang(config);
            let callToAction = config.callToAction || [];
            if (!Array.isArray(callToAction)) {
              callToAction = [callToAction];
            }
            config.callToAction = callToAction.map((cta, index) => {
              const c = Object.assign({}, defaultCta, { label: `CtA ${ index + 1 }` }, cta);
              if (c.pause !== true && !(c.pause > 0)) {
                c.pause = 0;
              }
              return c;
            });

            this.config = config;
            return response;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading channel info.');
            }
            this.setConfigDefault();
            return Promise.reject(rejection);
          });
      },
      setConfigDefault() {
        this.lang_default = this.langs[0].id;
        this.langs.forEach((lang) => {
          lang.selected = true;
        });
        const config = clone(defaultConfig);
        config.lang = this.langs.map((lang) => lang.id).join(',');
        this.config = config;
      },
      saveConfig() {
        return new Promise((resolve) => setTimeout(() => resolve(this.__saveConfig()), 1000));
      },
      __saveConfig() {
        const payload = {
          channel_id: this.channelId,
          description: this.config.description,
          iframe_config: JSON.stringify(this.config),
        };
        return this
          .startUpload()
          .then((files) => {
            if (files.facebook_img.length && files.facebook_img[0].__resourceUrl) {
              this.config.share.facebook_img = files.facebook_img[0].__resourceUrl;
              this.config.share.player.facebook_img = this.config.share.facebook_img;
              payload.iframe_config = JSON.stringify(this.config);
            }
            if (files.logo_img.length && files.logo_img[0].__resourceUrl) {
              this.config.logo_img = files.logo_img[0].__resourceUrl;
              payload.iframe_config = JSON.stringify(this.config);
            }
            if (files.demo_thumbnail_url.length && files.demo_thumbnail_url[0].__resourceUrl) {
              payload.demo_thumbnail_url = files.demo_thumbnail_url[0].__resourceUrl;
              this.config.demo_thumbnail_url = payload.demo_thumbnail_url;
            }
            return this.$http
              .post('/channel/update', stringify(payload, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              });
          })
          .then(() => {
            this.$q.notify({
              type: 'positive',
              message: 'Configuration saved',
              position: 'bottom-right',
            });
          })
          .catch((rejection) => {
            if (rejection.response) {
              showRejectionMessage(rejection, 'Error saving configuration');
            }
          });
      },
      setTitle(langId, val) {
        this.configVersion += 1;
        this.config.title[langId] = val;
      },
      setFacebookText(langId, val) {
        this.configVersion += 1;
        this.config.facebookText[langId] = val;
        if (langId !== '*' && (typeof this.config.facebookText['*'] !== 'string' || !this.config.facebookText['*'].length)) {
          this.config.facebookText['*'] = val;
        }
      },
      setTwitterText(langId, val) {
        this.configVersion += 1;
        this.config.twitterText[langId] = val;
        if (langId !== '*' && (typeof this.config.twitterText['*'] !== 'string' || !this.config.twitterText['*'].length)) {
          this.config.twitterText['*'] = val;
        }
      },
      setWhatsappText(langId, val) {
        this.configVersion += 1;
        this.config.whatsappText[langId] = val;
        if (langId !== '*' && (typeof this.config.whatsappText['*'] !== 'string' || !this.config.whatsappText['*'].length)) {
          this.config.whatsappText['*'] = val;
        }
      },
      setCallToAction(index, options) {
        const callToAction = this.config.callToAction.slice();
        Object.keys(options).forEach((k) => {
          callToAction[index][k] = options[k];
        });
        this.config.callToAction = callToAction;
      },
      removeCallToAction(index) {
        const callToAction = this.config.callToAction.slice();
        callToAction.splice(index, 1);
        this.config.callToAction = callToAction;
      },
      addCallToAction() {
        const callToAction = this.config.callToAction.slice();
        callToAction.push(Object.assign({}, defaultCta, { label: `CtA ${ callToAction.length + 1 }` }));
        this.config.callToAction = callToAction;
      },
      onChangeLang(config = this.config) {
        if (!this.langs.find((lang) => lang.selected && lang.id === this.lang_default)) {
          this.lang_default = null;
        }
        const sel = this.langs
          .filter((lang) => lang.selected && lang.id !== this.lang_default)
          .map((lang) => lang.id);
        if (this.lang_default) {
          sel.unshift(this.lang_default);
        } else if (sel.length) {
          [this.lang_default] = sel;
        }
        config.lang = sel.join(',');
      },
      onChangeRankingShow() {
        this.config.ranking_start = this.config.ranking_start && this.config.ranking_show;
      },
      onChangeRankingStart() {
        this.config.ranking_show = this.config.ranking_start || this.config.ranking_show;
      },
      onCtaOverlayOpen(index) {
        this.ctaOverlay.index = index;
        this.ctaOverlay.video = this.config.demo_video_url;
        try {
          this.ctaOverlay.style = JSON.parse(this.config.callToAction[index].style);
        } catch (e) {
          this.ctaOverlay.style = {
            top: '0%',
            left: '0%',
            bottom: '10%',
            right: '10%',
          };
        }
        this.ctaOverlay.open = true;
      },
      onCtaOverlayClose() {
        this.setCallToAction(this.ctaOverlay.index, { style: this.ctaOverlayStyle });
        this.ctaOverlay.open = false;
      },
      onCtaOverlayKey(ev, key) {
        if (![38, 40].includes(ev.keyCode)) {
          return;
        }
        const val = /^\s*(-?[\d.]+)(.*)\s*$/.exec(this.ctaOverlay.style[key]);
        if (val) {
          const offset = (ev.keyCode === 38 ? 1 : -1) * (ev.ctrlKey ? 10 : 1);
          const decimals = Math.max(1, (val[1].split('.')[1] || '').length);
          val[1] = (parseFloat(val[1]) + (offset / (ev.shiftKey ? 10 : 1))).toFixed(decimals);
        }
        this.ctaOverlay.style[key] = `${ val[1] }${ val[2] }`;
      },
      onCtaOverlayPan(key, ev) {
        if (key === 'all') {
          this.onCtaOverlayPan('right', ev);
          this.onCtaOverlayPan('left', ev);
          this.onCtaOverlayPan('top', ev);
          this.onCtaOverlayPan('bottom', ev);
          return;
        }

        const val = /^\s*(-?[\d.]+)(.*)\s*$/.exec(this.ctaOverlay.style[key]);
        if (!this.$refs.ctaOverlayItem || !this.$refs.ctaOverlayHolder || !val) {
          return;
        }

        const vertical = ['top', 'bottom'].includes(key);
        const offset = (['right', 'bottom'].includes(key) ? -1 : 1) * ev.delta[vertical ? 'y' : 'x'];
        if (val[2] === '%') {
          // const initial = this.$refs.ctaOverlayItem[vertical ? 'clientHeight' : 'clientWidth'];
          const total = this.$refs.ctaOverlayHolder[vertical ? 'clientHeight' : 'clientWidth'];
          val[1] = (parseFloat(val[1]) + (total ? (offset * 100) / total : 0)).toFixed(4);
        } else {
          val[1] = (parseFloat(val[1]) + offset).toFixed(0);
        }
        this.ctaOverlay.style[key] = `${ val[1] }${ val[2] }`;
      },
    },
    watch: {
      location() {
        this.initFiles();
        this.getConfig();
      },
      config: {
        handler: function config() {
          this.configVersion += 1;
        },
        deep: true,
      },
    },
    mounted() {
      this.initFiles();
      this.getConfig();
    },
  };
</script>
